#include <aimtrans.h>

ehandler ehandler_at;

void at_init()
{
    pth_attr_t attr;
    
    attr = pth_attr_new();
    pth_attr_set(attr, PTH_ATTR_JOINABLE, FALSE);
    pth_attr_set(attr, PTH_ATTR_STACK_SIZE, etherx_stack_default);

    pth_spawn(attr, at_unknown_main, NULL); /* the thread handling all unknown packets */
    
	ehandler_at = ehandler_new(&at_etherx_receive, at_name, "jabber:server");
	log_debug(ZONE, "[AIM] Loaded transport with %s as host alias\n", at_name);

	return;
}

void at_etherx_receive(epacket e)
{
	log_debug(ZONE, "[AIM] We got a packet from etherx");

    switch(e->type)
    {
        case EPACKET_NORMAL:
			xmlnode_hide_attrib(e->x, "etherx:to");
            xmlnode_hide_attrib(e->x, "etherx:from");
			at_parse_packet(e->x);
            break;
		case EPACKET_ERROR:
            log_debug(ZONE, "[AIM] packet error: %s\n", xmlnode2str(e->x));
            break;
    }

	return;
}
