#include <aimtrans.h>

session sessions = NULL;

void at_session_main(void *arg);

session at_session_create(char *user, char *pword, jid j, jid from)
{
	thread t;
	session new;
	struct aim_conn_t *authconn = NULL;
	//struct client_info_s info = {"Jabber", 3, 90, 42, "us", "en"};
	struct client_info_s info = {"AOL Instant Messenger (SM). version 3.5.1670/WIN32", 4, 3, 3141, "us", "en", 0x0004, 0x0001, 0x00055};
//struct client_info_s info = {"Random String (libfaim)", 4, 30, 3141, "us", "en"};
    pth_attr_t attr;

	new = at_session_find_by_jid(j);
	if(new!=NULL)
	{
		log_debug(ZONE, "[AIM] The goober is already online");
		return NULL;
	}
	log_debug(ZONE, "[AIM] New session for %s using %s, jid set to %s\n", user, 
					pword, jid_full(j));
	t = thread_new();
	new = pmalloc(t->p, sizeof(_session));
	t->data = (void *)new;
	new->j=jid_new(t->p, jid_full(j));
	new->from=jid_new(t->p, jid_full(from));
	aim_session_init(&new->ass);
	new->ass.aux_data = (void *)new;
    new->p = t->p;
	new->mp_to = pth_msgport_create("aimsession_to");
	new->loggedin = 0;
	new->buddies = NULL;
	new->profile = NULL;
	new->exit_flag = 0;
	new->next = sessions;
	sessions = new;

	aim_session_init(&new->ass);
	new->ass.aux_data = (void *)new;
	authconn = aim_newconn(&new->ass, AIM_CONN_TYPE_AUTH, FAIM_LOGIN_SERVER);
	if(authconn == NULL)
	{
		log_error("[AIM]", "Error connecting to aims authentication server.\n");
        thread_free(new);
		return NULL;
	} 
	else if (authconn->fd == -1)
	{
		if (authconn->status & AIM_CONN_STATUS_RESOLVERR)
			log_error("[AIM]", "faimtest: could not resolve authorizer name\n");
	    else if (authconn->status & AIM_CONN_STATUS_CONNERR)
			log_error("[AIM]", "faimtest: could not connect to authorizer\n");
        aim_conn_kill(&new->ass, &authconn);
        thread_free(new);
	    return NULL;
    }
  	else
    {
		aim_conn_addhandler(&new->ass, authconn, AIM_CB_FAM_SPECIAL, 
						AIM_CB_SPECIAL_AUTHSUCCESS, at_parse_authresp, 0);
      	aim_conn_addhandler(&new->ass, authconn, AIM_CB_FAM_GEN, 
						AIM_CB_GEN_SERVERREADY, at_authsvrready, 0);
      	aim_send_login(&new->ass, authconn, user, pword, &info); 
    }
	attr = pth_attr_new();
	pth_attr_set(attr, PTH_ATTR_JOINABLE, FALSE);
	t->id = pth_spawn(attr, (void *)&at_session_main, (void *)t);
	pth_attr_destroy(attr);
    pth_yield(NULL);
	log_debug(ZONE, "[AIM] We started a new session thread\n");

	return new;
}
	
void at_session_main(void *arg)
{
	thread t = (thread)arg;
    session s = (session)(t->data);
	pth_event_t to,done,ring;
	jpq q;
	xmlnode x;
	struct aim_conn_t *waitingconn = NULL;
    int status;

	to = pth_event(PTH_EVENT_MSG, s->mp_to);
	done = pth_event(PTH_EVENT_FUNC, at_session_isdone, s,pth_time(0,100000));
	ring = pth_event_concat(to, done, NULL); 

	/* Do stuff */
	log_debug(ZONE, "[AIM] In our main session\n");
	while ((waitingconn = _aim_select(&s->ass, ring, &status)) > 0)
    {
    /*    log_debug(ZONE, "[AIM] Got data from the select: %d", status);
      */
  
		if(s->exit_flag)
			break;

        switch(status)
        {
            case -1:
                /* There was an error */
                s->exit_flag = 1;
                break;
            case 0:
                /* Nothing to do */
                break;
            case 1:
			    log_debug(ZONE, "[AIM] Flushing outgoing queue\n");
    			aim_tx_flushqueue(&s->ass);
                break;
            case 2:
    		    if (aim_get_command(&s->ass, waitingconn) < 0)
                {
	    			/* XXX do something like send an error */
		    		log_debug(ZONE,"[AIM] connection error!\n");
			    	s->exit_flag = 1;
    			}
	        	else
		    	{
			    	aim_rxdispatch(&s->ass);
    			}
                break;
            case 3:
                log_debug(ZONE, "[AIM] Looking for data on the mp %X",s->mp_to);
		        while(1)
        		{
		        	q = (jpq)pth_msgport_get(s->mp_to);
        			if(q == NULL)
                    {
                        log_debug(ZONE, "[AIM] Nothing more on the mp\n");
		        		break;
                    }
                    at_aim_session_parser(s, q->p);
        		} 
                break;
        }

		if(s->exit_flag)
			break;
    }

	/* Close up */
	log_debug(ZONE,"[AIM] Closing up a main thread\n");
	/* close up all connections, dead or no */
	/*XXX this is causing TONS of crashes
	 * I'm just taking it out for now
	 */
	/*while(1)
    {
        q = (jpq)pth_msgport_get(s->mp_to);
        if(q == NULL)
            break;
        if(q->p->type == JPACKET_MESSAGE)
			at_aim_session_deliver(s, q->p->x, q->p->to);
        else
            xmlnode_free(q->p->x);
    }*/
	x = jutil_presnew(JPACKET__UNAVAILABLE, jid_full(s->j), "Disconnected");
	xmlnode_put_attrib(x, "from", jid_full(s->from));
	ehandler_send(ehandler_at, x, s->j->server);

    pth_msgport_destroy(s->mp_to);
	pth_event_free(ring, PTH_FREE_ALL);
  	aim_logoff(&s->ass);
        log_debug(ZONE,"[AIM] unlinking session");
	at_session_unlink(s);

	pth_yield(NULL);

    thread_free(t);

	return;
}

/* I'm hoping that I'll be able to deprecate this now */
int at_session_isdone(void *arg)
{
	session s = (session)arg;

	if(s->exit_flag)
		return 1;
	else
		return 0;
}
	
int at_aim_session_parser(session s, jpacket jp)
{
    char *name;
    xmlnode x;
    jid j; /* for ppdb check */

    log_debug(ZONE, "[AIM] Parsing Packet\n");
        
    switch(jp->type)
    {
        case JPACKET_IQ:
            if(NSCHECK(xmlnode_get_tag(jp->x, "query"),NS_REGISTER))
            {
                /* Register the user */
				at_auth_register(jp);
                break;
            }
            if(jp->subtype == JPACKET__GET)
            {
                if( j_strcmp( jp->iqns, "jabber:iq:version" ) == 0 )
                {
                    xmlnode iq, iqname;
                    log_debug(ZONE, "[AIM] Responding to version query\n");
                    iq = xmlnode_dup( jp->x );
                    xmlnode_put_attrib( iq, "to", jid_full(jp->from) );
                    xmlnode_put_attrib( iq, "from", jid_full(jp->to) );
                    xmlnode_put_attrib( iq, "type", "result" );
                    iqname = xmlnode_insert_tag( iq, "name" );
                    xmlnode_insert_cdata( iqname, "Jabber AIM Transport", -1);
                    ehandler_send( ehandler_at, iq, jp->from->server );
                }
                else if( j_strcmp( jp->iqns, "jabber:iq:time" ) == 0 )
                {
                    xmlnode iq;
                    log_debug(ZONE, "[AIM] Responding to time query\n");
                    iq = jutil_iqresult( jp->x );
                    xmlnode_put_attrib(iq,"to",jid_full(jp->from));
                    xmlnode_put_attrib(iq,"from",jid_full(jp->to));
                    xmlnode_insert_cdata( xmlnode_insert_tag( iq, "utc"),jutil_timestamp(),-1);
                    xmlnode_insert_cdata(xmlnode_insert_tag(iq,"tz"),"gmt",-1);
                    ehandler_send(ehandler_at,iq,jp->from->server);
                }
            } 
            break;
	    case JPACKET_MESSAGE:
            /* Put the message on the line for the session to handle */
            /* log_debug(ZONE, "[AIM] Sending a message"); */
            at_aim_session_deliver(s, jp->x, jp->to);
            break;
        case JPACKET_S10N:
            /* Handle a S10N packet based on their subtype */
            log_debug(ZONE, "[AIM] We got a s10n packet");
            switch(jpacket_subtype(jp))
            {
            case JPACKET__SUBSCRIBED:
                /* Do I need to do anything? */
                break;
            case JPACKET__UNSUBSCRIBED:
                /* Do I need to do anything? */
                break;
            case JPACKET__SUBSCRIBE:
                log_debug(ZONE, "[AIM] new subscription\n");
                if(jp->to->resource == NULL)
                    at_auth_add_buddy(jp);
                break;
            case JPACKET__UNSUBSCRIBE:
                /* Do more with this 
                * (Actually take the user off the aim roster)
               * should we check for a subscription as well? 
                */
                s=at_session_find_by_jid(jp->from);
                if(s==NULL)
                {
                    x = xmlnode_dup(jp->x);
                    jutil_error(x, TERROR_REGISTER);
                    ehandler_send(ehandler_at, x, jp->from->server);
                    break;
                }
                at_session_buddy_unlink(s, jp->to->user);
                aim_remove_buddy(&s->ass, aim_getconn_type(&s->ass,
                                AIM_CONN_TYPE_BOS), jp->to->user);
                log_debug(ZONE, "[AIM] Unsubscribing\n");
                x = xmlnode_dup(jp->x);
                xmlnode_put_attrib(x, "type", "unsubscribed");
                xmlnode_put_attrib(x, "to", jid_full(jp->from));
                xmlnode_hide_attrib(x, "from");
                ehandler_send(ehandler_at, x, jp->from->server);
                break;
			}
		case JPACKET_PRESENCE:
			switch(jpacket_subtype(jp))
			{
		case JPACKET__PROBE:
				log_debug(ZONE, "[AIM] Probed, no logical way to handle\n");
				break;
		case JPACKET__UNAVAILABLE:
            /* insert into ppdb, check to see if we should go offline */
            PPDB=ppdb_insert(PPDB,jp->from,jp->x);
            j=jid_new(jp->p,jid_full(jp->from));
            jid_set(j,NULL,JID_RESOURCE);
            x=ppdb_primary(PPDB,j);
            if(x!=NULL)
            {
                /* not last resource, don't go offline yet */
				log_debug(ZONE, "[AIM] More resources active, not ending session");
                break;
            }
			log_debug(ZONE, "[AIM] Telling the session to end!\n");
			s = at_session_find_by_jid(jp->from);
			if(s==NULL)
				break;
			at_session_end(s);
			break;
		case JPACKET__AVAILABLE:
                PPDB=ppdb_insert(PPDB,jp->from,jp->x);
				log_debug(ZONE, "[AIM] Starting a new session!\n");
                s=at_session_find_by_jid(jp->from);
                log_debug(ZONE, "[AIM] S is: %X", s);
				if((s) && (xmlnode_get_tag(jp->x, "show") != NULL))
                {
                    /* why are we returning here? 
                    * this doesn't seem like the proper way
                    * to handle this...
                    */   
                    char *awaymsg;
                    char profile[]="";

                    awaymsg = xmlnode_get_tag_data(jp->x, "status");
                    log_debug(ZONE, "[AIM] Setting user away\n");
                    aim_bos_setprofile(&s->ass, 
                            aim_getconn_type(&s->ass, AIM_CONN_TYPE_BOS),
                            profile, awaymsg, AIM_CAPS_CHAT);
                    /* at_psend(s->mp_to, jp, 0); */
					return;
                }
				if(jp->to->resource == NULL)
				{
					at_auth_add_buddy(jp);
					return;
				} else {
                    char profile[] = "";
                    /* user is already connected, don't start a new session */
                    /* No show let's reset their profile */
                    log_debug(ZONE, "[AIM] Setting user away\n");
                    if(s!=NULL)
                    {
                        aim_bos_setprofile(&s->ass, 
                                aim_getconn_type(&s->ass, AIM_CONN_TYPE_BOS),
                                profile, NULL, AIM_CAPS_CHAT);
                        /* at_psend(s->mp_to, jp, 0); */
                        break;
                    }
					at_auth_user(xmlnode_dup(jp->x));
				}
                x = xmlnode_dup(jp->x);
				xmlnode_put_attrib(x, "from", jid_full(jp->to));
				xmlnode_put_attrib(x, "to", jid_full(jp->from));
				ehandler_send(ehandler_at, x, jp->from->server);

				break;
			}
            break;
        default:
            /* XXX do more!? */
            xmlnode_free(jp->x);
            break;
	}

	return 0;
}

void at_aim_session_deliver(session s, xmlnode x, jid from)
{
	/* XXX Deliver to aim user */
	char *body;

	body = UTF8_to_str(xmlnode_pool(x),xmlnode_get_tag_data(x, "body"));

	if(body == NULL || from->user == NULL)
		return;

log_debug(ZONE, "[AIM] Sending a Message");
	aim_send_im(&s->ass, aim_getconn_type(&s->ass, AIM_CONN_TYPE_BOS), from->user, 0, body);
	return;
}

void at_session_end(session s)
{
//	log_debug(ZONE, "[AIM] Session told to end.\n");
	s->exit_flag = 1;
	pth_msgport_put(s->mp_to, NULL);
	return;
}
	
void at_session_unlink(session s)
{
	session next;
	session prev;
	
	if(s == NULL)
		return;
        log_debug(ZONE, "[AIM] starting to unlink");

	for(prev=NULL,next = sessions;next != NULL; next = next->next)
	{
		log_debug(ZONE, "[AIM] comparing (%s) and (%s)\n", jid_full(next->j),jid_full(s->j));
        
		if(jid_cmp(s->j, next->j)==0)
		{
			if(prev ==NULL)
            {
			    prev=next->next;
			    sessions=prev;
            }
            else
				prev->next = next->next;
            log_debug(ZONE, "[AIM] Unlinked group %s\n", jid_full(next->j));
			return;
		}
		prev = next;
	}

	return;

}

void at_session_buddy_unlink(session s, char *user)
{
	at_buddy next;
	at_buddy prev;
	
	if(user == NULL || s == NULL)
		return;
    log_debug(ZONE, "[AIM] starting to unlink");

	for(prev=NULL,next = s->buddies;next != NULL; next = next->next)
	{
        if(j_strcmp(next->to->user, user)==0)
        {
            if(prev ==NULL)
            {
                prev=next->next;
			    s->buddies=prev;
            }
            else
			    prev->next = next->next;
			    log_debug(ZONE, "[AIM] Unlinked buddy %s\n", jid_full(next->to));
                /* XXX Sort of a mem leak here by not freeing on pool */
			return;
		}
		prev = next;
	}

	return;

}

session at_session_find_by_jid(jid j)
{
	session next;

	if(j == NULL || sessions == NULL)
		return NULL;

	for(next = sessions; next != NULL; next = next->next)
	{
        if(next!=NULL)
            if(j_strcmp(j->user, next->j->user)==0 && j_strcmp(j->server, next->j->server) == 0)
                return next;
    }
	
    return NULL;
}
